local __exports = LibStub:NewLibrary("ovale/scripts/ovale_paladin", 90104)
if not __exports then return end
__exports.registerPaladin = function(scripts)
    do
        local name = "sc_t26_paladin_protection"
        local desc = "[9.0] Simulationcraft: T26_Paladin_Protection"
        local code = [[
# Based on SimulationCraft profile "T26_Paladin_Protection".
#	class=paladin
#	spec=protection
#	talents=2200202

Include(ovale_common)
Include(ovale_paladin_spells)

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(protection)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(protection)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(protection)))

AddFunction protectioninterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(rebuke) and target.isinterruptible() spell(rebuke)
  if target.inrange(avengers_shield) and target.isinterruptible() spell(avengers_shield)
  if target.inrange(hammer_of_justice) and not target.classification(worldboss) spell(hammer_of_justice)
  if target.distance() < 10 and not target.classification(worldboss) spell(blinding_light)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
 }
}

AddFunction protectionuseitemactions
{
 item(trinket0slot text=13 usable=1)
 item(trinket1slot text=14 usable=1)
}

AddFunction protectiongetinmeleerange
{
 if checkboxon(opt_melee_range) and not target.inrange(rebuke) texture(misc_arrowlup help=(l(not_in_melee_range)))
}

### actions.standard

AddFunction protectionstandardmainactions
{
 #shield_of_the_righteous,if=debuff.judgment.up
 if target.debuffpresent(judgment_protection) spell(shield_of_the_righteous)
 #shield_of_the_righteous,if=holy_power=5|buff.holy_avenger.up|holy_power=4&talent.sanctified_wrath.enabled&buff.avenging_wrath.up
 if holypower() == 5 or buffpresent(holy_avenger) or holypower() == 4 and hastalent(sanctified_wrath_talent_protection) and buffpresent(avenging_wrath) spell(shield_of_the_righteous)
 #judgment,target_if=min:debuff.judgment.remains,if=charges=2|!talent.crusaders_judgment.enabled
 if charges(judgment_protection) == 2 or not hastalent(crusaders_judgment_talent) spell(judgment_protection)
 #hammer_of_wrath
 spell(hammer_of_wrath)
 #blessing_of_the_seasons
 spell(blessing_of_the_seasons)
 #avengers_shield
 spell(avengers_shield)
 #judgment,target_if=min:debuff.judgment.remains
 spell(judgment_protection)
 #consecration,if=!consecration.up
 if not buffpresent(consecration) spell(consecration)
 #blessed_hammer,strikes=2.4,if=charges=3
 if charges(blessed_hammer) == 3 spell(blessed_hammer)
 #hammer_of_the_righteous,if=charges=2
 if charges(hammer_of_the_righteous) == 2 spell(hammer_of_the_righteous)
 #word_of_glory,if=buff.vanquishers_hammer.up
 if buffpresent(vanquishers_hammer) spell(word_of_glory)
 #blessed_hammer,strikes=2.4
 spell(blessed_hammer)
 #hammer_of_the_righteous
 spell(hammer_of_the_righteous)
 #consecration
 spell(consecration)
 #word_of_glory,if=buff.shining_light_free.up&!covenant.necrolord
 if buffpresent(shining_light_free_buff) and not iscovenant("necrolord") spell(word_of_glory)
}

AddFunction protectionstandardmainpostconditions
{
}

AddFunction protectionstandardshortcdactions
{
 unless target.debuffpresent(judgment_protection) and spell(shield_of_the_righteous) or { holypower() == 5 or buffpresent(holy_avenger) or holypower() == 4 and hastalent(sanctified_wrath_talent_protection) and buffpresent(avenging_wrath) } and spell(shield_of_the_righteous) or { charges(judgment_protection) == 2 or not hastalent(crusaders_judgment_talent) } and spell(judgment_protection) or spell(hammer_of_wrath) or spell(blessing_of_the_seasons) or spell(avengers_shield) or spell(judgment_protection)
 {
  #vanquishers_hammer
  spell(vanquishers_hammer)

  unless not buffpresent(consecration) and spell(consecration)
  {
   #divine_toll
   spell(divine_toll)
  }
 }
}

AddFunction protectionstandardshortcdpostconditions
{
 target.debuffpresent(judgment_protection) and spell(shield_of_the_righteous) or { holypower() == 5 or buffpresent(holy_avenger) or holypower() == 4 and hastalent(sanctified_wrath_talent_protection) and buffpresent(avenging_wrath) } and spell(shield_of_the_righteous) or { charges(judgment_protection) == 2 or not hastalent(crusaders_judgment_talent) } and spell(judgment_protection) or spell(hammer_of_wrath) or spell(blessing_of_the_seasons) or spell(avengers_shield) or spell(judgment_protection) or not buffpresent(consecration) and spell(consecration) or charges(blessed_hammer) == 3 and spell(blessed_hammer) or charges(hammer_of_the_righteous) == 2 and spell(hammer_of_the_righteous) or buffpresent(vanquishers_hammer) and spell(word_of_glory) or spell(blessed_hammer) or spell(hammer_of_the_righteous) or spell(consecration) or buffpresent(shining_light_free_buff) and not iscovenant("necrolord") and spell(word_of_glory)
}

AddFunction protectionstandardcdactions
{
 unless target.debuffpresent(judgment_protection) and spell(shield_of_the_righteous) or { holypower() == 5 or buffpresent(holy_avenger) or holypower() == 4 and hastalent(sanctified_wrath_talent_protection) and buffpresent(avenging_wrath) } and spell(shield_of_the_righteous) or { charges(judgment_protection) == 2 or not hastalent(crusaders_judgment_talent) } and spell(judgment_protection) or spell(hammer_of_wrath) or spell(blessing_of_the_seasons) or spell(avengers_shield) or spell(judgment_protection) or spell(vanquishers_hammer) or not buffpresent(consecration) and spell(consecration) or spell(divine_toll) or charges(blessed_hammer) == 3 and spell(blessed_hammer)
 {
  #ashen_hallow
  spell(ashen_hallow)

  unless charges(hammer_of_the_righteous) == 2 and spell(hammer_of_the_righteous) or buffpresent(vanquishers_hammer) and spell(word_of_glory) or spell(blessed_hammer) or spell(hammer_of_the_righteous)
  {
   #lights_judgment
   spell(lights_judgment)
   #arcane_torrent
   spell(arcane_torrent)
  }
 }
}

AddFunction protectionstandardcdpostconditions
{
 target.debuffpresent(judgment_protection) and spell(shield_of_the_righteous) or { holypower() == 5 or buffpresent(holy_avenger) or holypower() == 4 and hastalent(sanctified_wrath_talent_protection) and buffpresent(avenging_wrath) } and spell(shield_of_the_righteous) or { charges(judgment_protection) == 2 or not hastalent(crusaders_judgment_talent) } and spell(judgment_protection) or spell(hammer_of_wrath) or spell(blessing_of_the_seasons) or spell(avengers_shield) or spell(judgment_protection) or spell(vanquishers_hammer) or not buffpresent(consecration) and spell(consecration) or spell(divine_toll) or charges(blessed_hammer) == 3 and spell(blessed_hammer) or charges(hammer_of_the_righteous) == 2 and spell(hammer_of_the_righteous) or buffpresent(vanquishers_hammer) and spell(word_of_glory) or spell(blessed_hammer) or spell(hammer_of_the_righteous) or spell(consecration) or buffpresent(shining_light_free_buff) and not iscovenant("necrolord") and spell(word_of_glory)
}

### actions.precombat

AddFunction protectionprecombatmainactions
{
 #flask
 #food
 #augmentation
 #devotion_aura
 if buffexpires(devotion_aura) spell(devotion_aura)
 #consecration
 spell(consecration)
}

AddFunction protectionprecombatmainpostconditions
{
}

AddFunction protectionprecombatshortcdactions
{
}

AddFunction protectionprecombatshortcdpostconditions
{
 buffexpires(devotion_aura) and spell(devotion_aura) or spell(consecration)
}

AddFunction protectionprecombatcdactions
{
 unless buffexpires(devotion_aura) and spell(devotion_aura)
 {
  #snapshot_stats
  #potion
  if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_phantom_fire_item usable=1)

  unless spell(consecration)
  {
   #lights_judgment
   spell(lights_judgment)
  }
 }
}

AddFunction protectionprecombatcdpostconditions
{
 buffexpires(devotion_aura) and spell(devotion_aura) or spell(consecration)
}

### actions.cooldowns

AddFunction protectioncooldownsmainactions
{
 #heart_essence
 if hasequippeditem(158075) and level() < 50 spell(296208)
}

AddFunction protectioncooldownsmainpostconditions
{
}

AddFunction protectioncooldownsshortcdactions
{
 #seraphim
 spell(seraphim)
 #moment_of_glory,if=prev_gcd.1.avengers_shield&cooldown.avengers_shield.remains
 if previousgcdspell(avengers_shield) and spellcooldown(avengers_shield) > 0 spell(moment_of_glory)
}

AddFunction protectioncooldownsshortcdpostconditions
{
 hasequippeditem(158075) and level() < 50 and spell(296208)
}

AddFunction protectioncooldownscdactions
{
 #fireblood,if=buff.avenging_wrath.up
 if buffpresent(avenging_wrath) spell(fireblood)

 unless spell(seraphim)
 {
  #avenging_wrath
  spell(avenging_wrath)
  #holy_avenger,if=buff.avenging_wrath.up|cooldown.avenging_wrath.remains>60
  if buffpresent(avenging_wrath) or spellcooldown(avenging_wrath) > 60 spell(holy_avenger)
  #potion,if=buff.avenging_wrath.up
  if buffpresent(avenging_wrath) and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_phantom_fire_item usable=1)
  #use_items,if=buff.seraphim.up|!talent.seraphim.enabled
  if buffpresent(seraphim) or not hastalent(seraphim_talent) protectionuseitemactions()
 }
}

AddFunction protectioncooldownscdpostconditions
{
 spell(seraphim) or previousgcdspell(avengers_shield) and spellcooldown(avengers_shield) > 0 and spell(moment_of_glory) or hasequippeditem(158075) and level() < 50 and spell(296208)
}

### actions.default

AddFunction protection_defaultmainactions
{
 #call_action_list,name=cooldowns
 protectioncooldownsmainactions()

 unless protectioncooldownsmainpostconditions()
 {
  #call_action_list,name=standard
  protectionstandardmainactions()
 }
}

AddFunction protection_defaultmainpostconditions
{
 protectioncooldownsmainpostconditions() or protectionstandardmainpostconditions()
}

AddFunction protection_defaultshortcdactions
{
 #auto_attack
 protectiongetinmeleerange()
 #call_action_list,name=cooldowns
 protectioncooldownsshortcdactions()

 unless protectioncooldownsshortcdpostconditions()
 {
  #call_action_list,name=standard
  protectionstandardshortcdactions()
 }
}

AddFunction protection_defaultshortcdpostconditions
{
 protectioncooldownsshortcdpostconditions() or protectionstandardshortcdpostconditions()
}

AddFunction protection_defaultcdactions
{
 protectioninterruptactions()
 #call_action_list,name=cooldowns
 protectioncooldownscdactions()

 unless protectioncooldownscdpostconditions()
 {
  #call_action_list,name=standard
  protectionstandardcdactions()
 }
}

AddFunction protection_defaultcdpostconditions
{
 protectioncooldownscdpostconditions() or protectionstandardcdpostconditions()
}

### Protection icons.

AddCheckBox(opt_paladin_protection_aoe l(aoe) default enabled=(specialization(protection)))

AddIcon enabled=(not checkboxon(opt_paladin_protection_aoe) and specialization(protection)) enemies=1 help=shortcd
{
 if not incombat() protectionprecombatshortcdactions()
 protection_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_paladin_protection_aoe) and specialization(protection)) help=shortcd
{
 if not incombat() protectionprecombatshortcdactions()
 protection_defaultshortcdactions()
}

AddIcon enabled=(specialization(protection)) enemies=1 help=main
{
 if not incombat() protectionprecombatmainactions()
 protection_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_paladin_protection_aoe) and specialization(protection)) help=aoe
{
 if not incombat() protectionprecombatmainactions()
 protection_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_paladin_protection_aoe) and specialization(protection)) enemies=1 help=cd
{
 if not incombat() protectionprecombatcdactions()
 protection_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_paladin_protection_aoe) and specialization(protection)) help=cd
{
 if not incombat() protectionprecombatcdactions()
 protection_defaultcdactions()
}

### Required symbols
# arcane_torrent
# ashen_hallow
# avengers_shield
# avenging_wrath
# blessed_hammer
# blessing_of_the_seasons
# blinding_light
# consecration
# crusaders_judgment_talent
# devotion_aura
# divine_toll
# fireblood
# hammer_of_justice
# hammer_of_the_righteous
# hammer_of_wrath
# holy_avenger
# judgment_protection
# lights_judgment
# moment_of_glory
# potion_of_phantom_fire_item
# rebuke
# sanctified_wrath_talent_protection
# seraphim
# seraphim_talent
# shield_of_the_righteous
# shining_light_free_buff
# vanquishers_hammer
# war_stomp
# word_of_glory
]]
        scripts:registerScript("PALADIN", "protection", name, desc, code, "script")
    end
    do
        local name = "sc_t26_paladin_retribution"
        local desc = "[9.0] Simulationcraft: T26_Paladin_Retribution"
        local code = [[
# Based on SimulationCraft profile "T26_Paladin_Retribution".
#	class=paladin
#	spec=retribution
#	talents=2201102

Include(ovale_common)
Include(ovale_paladin_spells)


AddFunction ds_castable
{
 enemies(tagged=1) >= 2 or buffpresent(empyrean_power_buff) and target.debuffexpires(judgment_debuff) and buffexpires(divine_purpose_buff)
}

AddCheckBox(opt_interrupt l(interrupt) default enabled=(specialization(retribution)))
AddCheckBox(opt_melee_range l(not_in_melee_range) enabled=(specialization(retribution)))
AddCheckBox(opt_use_consumables l(opt_use_consumables) default enabled=(specialization(retribution)))
AddCheckBox(opt_shield_of_vengeance spellname(shield_of_vengeance) enabled=(specialization(retribution)))

AddFunction retributioninterruptactions
{
 if checkboxon(opt_interrupt) and not target.isfriend() and target.casting()
 {
  if target.inrange(rebuke) and target.isinterruptible() spell(rebuke)
  if target.inrange(hammer_of_justice) and not target.classification(worldboss) spell(hammer_of_justice)
  if target.distance() < 5 and not target.classification(worldboss) spell(war_stomp)
 }
}

AddFunction retributionuseitemactions
{
 item(trinket0slot text=13 usable=1)
 item(trinket1slot text=14 usable=1)
}

AddFunction retributiongetinmeleerange
{
 if checkboxon(opt_melee_range) and not target.inrange(rebuke) texture(misc_arrowlup help=(l(not_in_melee_range)))
}

AddFunction retributiontimetohpg
{
 spellcooldown(crusader_strike hammer_of_wrath judgment usable=1)
}

### actions.precombat

AddFunction retributionprecombatmainactions
{
 #blessing_of_the_seasons
 spell(blessing_of_the_seasons)
}

AddFunction retributionprecombatmainpostconditions
{
}

AddFunction retributionprecombatshortcdactions
{
}

AddFunction retributionprecombatshortcdpostconditions
{
 spell(blessing_of_the_seasons)
}

AddFunction retributionprecombatcdactions
{
 #flask
 #food
 #augmentation
 #snapshot_stats
 #potion
 if checkboxon(opt_use_consumables) and target.classification(worldboss) item(potion_of_spectral_strength_item usable=1)
 #arcane_torrent
 spell(arcane_torrent)
}

AddFunction retributionprecombatcdpostconditions
{
 spell(blessing_of_the_seasons)
}

### actions.generators

AddFunction retributiongeneratorsmainactions
{
 #call_action_list,name=finishers,if=holy_power=5|buff.holy_avenger.up|debuff.final_reckoning.up|debuff.execution_sentence.up
 if holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) retributionfinishersmainactions()

 unless { holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) } and retributionfinishersmainpostconditions()
 {
  #blade_of_justice,if=holy_power<=3&talent.execution_sentence.enabled&(debuff.execution_sentence.up|cooldown.execution_sentence.remains=0)
  if holypower() <= 3 and hastalent(execution_sentence_talent) and { target.debuffpresent(execution_sentence) or not spellcooldown(execution_sentence) > 0 } spell(blade_of_justice)
  #hammer_of_wrath
  spell(hammer_of_wrath)
  #blade_of_justice,if=holy_power<=3
  if holypower() <= 3 spell(blade_of_justice)
  #judgment,if=!debuff.judgment.up
  if not target.debuffpresent(judgment_debuff) spell(judgment)
  #call_action_list,name=finishers,if=(target.health.pct<=20|buff.avenging_wrath.up|buff.crusade.up|buff.empyrean_power.up)
  if target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) retributionfinishersmainactions()

  unless { target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) } and retributionfinishersmainpostconditions()
  {
   #crusader_strike,if=cooldown.crusader_strike.charges_fractional>=1.75&(holy_power<=2|holy_power<=3&cooldown.blade_of_justice.remains>gcd*2|holy_power=4&cooldown.blade_of_justice.remains>gcd*2&cooldown.judgment.remains>gcd*2)
   if spellcharges(crusader_strike count=0) >= 1.75 and { holypower() <= 2 or holypower() <= 3 and spellcooldown(blade_of_justice) > gcd() * 2 or holypower() == 4 and spellcooldown(blade_of_justice) > gcd() * 2 and spellcooldown(judgment) > gcd() * 2 } spell(crusader_strike)
   #consecration,if=!consecration.up&spell_targets.divine_storm>=2
   if not buffpresent(consecration) and enemies(tagged=1) >= 2 spell(consecration)
   #call_action_list,name=finishers
   retributionfinishersmainactions()

   unless retributionfinishersmainpostconditions()
   {
    #consecration,if=!consecration.up
    if not buffpresent(consecration) spell(consecration)
    #crusader_strike
    spell(crusader_strike)
    #consecration,if=time_to_hpg>gcd
    if retributiontimetohpg() > gcd() spell(consecration)
   }
  }
 }
}

AddFunction retributiongeneratorsmainpostconditions
{
 { holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) } and retributionfinishersmainpostconditions() or { target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) } and retributionfinishersmainpostconditions() or retributionfinishersmainpostconditions()
}

AddFunction retributiongeneratorsshortcdactions
{
 #call_action_list,name=finishers,if=holy_power=5|buff.holy_avenger.up|debuff.final_reckoning.up|debuff.execution_sentence.up
 if holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) retributionfinishersshortcdactions()

 unless { holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) } and retributionfinishersshortcdpostconditions()
 {
  #divine_toll,if=!debuff.judgment.up&(!raid_event.adds.exists|raid_event.adds.in>30)&(holy_power<=2|holy_power<=4&(cooldown.blade_of_justice.remains>gcd*2|(debuff.execution_sentence.up|target.time_to_die<8)|debuff.final_reckoning.up))&(!talent.final_reckoning.enabled|cooldown.final_reckoning.remains>gcd*10)&(!talent.execution_sentence.enabled|(cooldown.execution_sentence.remains>gcd*10|target.time_to_die<8))&(cooldown.avenging_wrath.remains>0|cooldown.crusade.remains>0)
  if not target.debuffpresent(judgment_debuff) and { not never(raid_event_adds_exists) or 600 > 30 } and { holypower() <= 2 or holypower() <= 4 and { spellcooldown(blade_of_justice) > gcd() * 2 or target.debuffpresent(execution_sentence) or target.timetodie() < 8 or target.debuffpresent(final_reckoning) } } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > gcd() * 10 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > gcd() * 10 or target.timetodie() < 8 } and { spellcooldown(avenging_wrath) > 0 or spellcooldown(crusade) > 0 } spell(divine_toll)
  #wake_of_ashes,if=(holy_power=0|holy_power<=2&(cooldown.blade_of_justice.remains>gcd*2|(debuff.execution_sentence.up|target.time_to_die<8)|debuff.final_reckoning.up))&(!raid_event.adds.exists|raid_event.adds.in>20)&(!talent.execution_sentence.enabled|cooldown.execution_sentence.remains>15)&(!talent.final_reckoning.enabled|cooldown.final_reckoning.remains>15)&(cooldown.avenging_wrath.remains>0|cooldown.crusade.remains>0)
  if { holypower() == 0 or holypower() <= 2 and { spellcooldown(blade_of_justice) > gcd() * 2 or target.debuffpresent(execution_sentence) or target.timetodie() < 8 or target.debuffpresent(final_reckoning) } } and { not never(raid_event_adds_exists) or 600 > 20 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > 15 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > 15 } and { spellcooldown(avenging_wrath) > 0 or spellcooldown(crusade) > 0 } spell(wake_of_ashes)

  unless holypower() <= 3 and hastalent(execution_sentence_talent) and { target.debuffpresent(execution_sentence) or not spellcooldown(execution_sentence) > 0 } and spell(blade_of_justice) or spell(hammer_of_wrath) or holypower() <= 3 and spell(blade_of_justice) or not target.debuffpresent(judgment_debuff) and spell(judgment)
  {
   #call_action_list,name=finishers,if=(target.health.pct<=20|buff.avenging_wrath.up|buff.crusade.up|buff.empyrean_power.up)
   if target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) retributionfinishersshortcdactions()

   unless { target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) } and retributionfinishersshortcdpostconditions() or spellcharges(crusader_strike count=0) >= 1.75 and { holypower() <= 2 or holypower() <= 3 and spellcooldown(blade_of_justice) > gcd() * 2 or holypower() == 4 and spellcooldown(blade_of_justice) > gcd() * 2 and spellcooldown(judgment) > gcd() * 2 } and spell(crusader_strike) or not buffpresent(consecration) and enemies(tagged=1) >= 2 and spell(consecration)
   {
    #call_action_list,name=finishers
    retributionfinishersshortcdactions()
   }
  }
 }
}

AddFunction retributiongeneratorsshortcdpostconditions
{
 { holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) } and retributionfinishersshortcdpostconditions() or holypower() <= 3 and hastalent(execution_sentence_talent) and { target.debuffpresent(execution_sentence) or not spellcooldown(execution_sentence) > 0 } and spell(blade_of_justice) or spell(hammer_of_wrath) or holypower() <= 3 and spell(blade_of_justice) or not target.debuffpresent(judgment_debuff) and spell(judgment) or { target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) } and retributionfinishersshortcdpostconditions() or spellcharges(crusader_strike count=0) >= 1.75 and { holypower() <= 2 or holypower() <= 3 and spellcooldown(blade_of_justice) > gcd() * 2 or holypower() == 4 and spellcooldown(blade_of_justice) > gcd() * 2 and spellcooldown(judgment) > gcd() * 2 } and spell(crusader_strike) or not buffpresent(consecration) and enemies(tagged=1) >= 2 and spell(consecration) or retributionfinishersshortcdpostconditions() or not buffpresent(consecration) and spell(consecration) or spell(crusader_strike) or retributiontimetohpg() > gcd() and spell(consecration)
}

AddFunction retributiongeneratorscdactions
{
 #call_action_list,name=finishers,if=holy_power=5|buff.holy_avenger.up|debuff.final_reckoning.up|debuff.execution_sentence.up
 if holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) retributionfinisherscdactions()

 unless { holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) } and retributionfinisherscdpostconditions() or not target.debuffpresent(judgment_debuff) and { not never(raid_event_adds_exists) or 600 > 30 } and { holypower() <= 2 or holypower() <= 4 and { spellcooldown(blade_of_justice) > gcd() * 2 or target.debuffpresent(execution_sentence) or target.timetodie() < 8 or target.debuffpresent(final_reckoning) } } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > gcd() * 10 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > gcd() * 10 or target.timetodie() < 8 } and { spellcooldown(avenging_wrath) > 0 or spellcooldown(crusade) > 0 } and spell(divine_toll) or { holypower() == 0 or holypower() <= 2 and { spellcooldown(blade_of_justice) > gcd() * 2 or target.debuffpresent(execution_sentence) or target.timetodie() < 8 or target.debuffpresent(final_reckoning) } } and { not never(raid_event_adds_exists) or 600 > 20 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > 15 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > 15 } and { spellcooldown(avenging_wrath) > 0 or spellcooldown(crusade) > 0 } and spell(wake_of_ashes) or holypower() <= 3 and hastalent(execution_sentence_talent) and { target.debuffpresent(execution_sentence) or not spellcooldown(execution_sentence) > 0 } and spell(blade_of_justice) or spell(hammer_of_wrath) or holypower() <= 3 and spell(blade_of_justice) or not target.debuffpresent(judgment_debuff) and spell(judgment)
 {
  #call_action_list,name=finishers,if=(target.health.pct<=20|buff.avenging_wrath.up|buff.crusade.up|buff.empyrean_power.up)
  if target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) retributionfinisherscdactions()

  unless { target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) } and retributionfinisherscdpostconditions() or spellcharges(crusader_strike count=0) >= 1.75 and { holypower() <= 2 or holypower() <= 3 and spellcooldown(blade_of_justice) > gcd() * 2 or holypower() == 4 and spellcooldown(blade_of_justice) > gcd() * 2 and spellcooldown(judgment) > gcd() * 2 } and spell(crusader_strike) or not buffpresent(consecration) and enemies(tagged=1) >= 2 and spell(consecration)
  {
   #call_action_list,name=finishers
   retributionfinisherscdactions()

   unless retributionfinisherscdpostconditions() or not buffpresent(consecration) and spell(consecration) or spell(crusader_strike)
   {
    #arcane_torrent
    spell(arcane_torrent)
   }
  }
 }
}

AddFunction retributiongeneratorscdpostconditions
{
 { holypower() == 5 or buffpresent(holy_avenger) or target.debuffpresent(final_reckoning) or target.debuffpresent(execution_sentence) } and retributionfinisherscdpostconditions() or not target.debuffpresent(judgment_debuff) and { not never(raid_event_adds_exists) or 600 > 30 } and { holypower() <= 2 or holypower() <= 4 and { spellcooldown(blade_of_justice) > gcd() * 2 or target.debuffpresent(execution_sentence) or target.timetodie() < 8 or target.debuffpresent(final_reckoning) } } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > gcd() * 10 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > gcd() * 10 or target.timetodie() < 8 } and { spellcooldown(avenging_wrath) > 0 or spellcooldown(crusade) > 0 } and spell(divine_toll) or { holypower() == 0 or holypower() <= 2 and { spellcooldown(blade_of_justice) > gcd() * 2 or target.debuffpresent(execution_sentence) or target.timetodie() < 8 or target.debuffpresent(final_reckoning) } } and { not never(raid_event_adds_exists) or 600 > 20 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > 15 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > 15 } and { spellcooldown(avenging_wrath) > 0 or spellcooldown(crusade) > 0 } and spell(wake_of_ashes) or holypower() <= 3 and hastalent(execution_sentence_talent) and { target.debuffpresent(execution_sentence) or not spellcooldown(execution_sentence) > 0 } and spell(blade_of_justice) or spell(hammer_of_wrath) or holypower() <= 3 and spell(blade_of_justice) or not target.debuffpresent(judgment_debuff) and spell(judgment) or { target.healthpercent() <= 20 or buffpresent(avenging_wrath) or buffpresent(crusade) or buffpresent(empyrean_power_buff) } and retributionfinisherscdpostconditions() or spellcharges(crusader_strike count=0) >= 1.75 and { holypower() <= 2 or holypower() <= 3 and spellcooldown(blade_of_justice) > gcd() * 2 or holypower() == 4 and spellcooldown(blade_of_justice) > gcd() * 2 and spellcooldown(judgment) > gcd() * 2 } and spell(crusader_strike) or not buffpresent(consecration) and enemies(tagged=1) >= 2 and spell(consecration) or retributionfinisherscdpostconditions() or not buffpresent(consecration) and spell(consecration) or spell(crusader_strike) or retributiontimetohpg() > gcd() and spell(consecration)
}

### actions.finishers

AddFunction retributionfinishersmainactions
{
 #divine_storm,if=variable.ds_castable&!buff.vanquishers_hammer.up&((!talent.crusade.enabled|cooldown.crusade.remains>gcd*3)&(!talent.execution_sentence.enabled|(cooldown.execution_sentence.remains%gcd+holy_power>7|target.time_to_die<8))&(!talent.final_reckoning.enabled|cooldown.final_reckoning.remains%gcd+holy_power>7)|spell_targets.divine_storm>=2&(talent.holy_avenger.enabled&cooldown.holy_avenger.remains<gcd*3|buff.crusade.up&buff.crusade.stack<10))
 if ds_castable() and not buffpresent(vanquishers_hammer) and { { not hastalent(crusade_talent) or spellcooldown(crusade) > gcd() * 3 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) / gcd() + holypower() > 7 or target.timetodie() < 8 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) / gcd() + holypower() > 7 } or enemies(tagged=1) >= 2 and { hastalent(holy_avenger_talent) and spellcooldown(holy_avenger) < gcd() * 3 or buffpresent(crusade) and buffstacks(crusade) < 10 } } spell(divine_storm)
 #templars_verdict,if=(!talent.crusade.enabled|cooldown.crusade.remains>gcd*3)&(!talent.execution_sentence.enabled|(cooldown.execution_sentence.remains%gcd+holy_power>7|target.time_to_die<8))&(!talent.final_reckoning.enabled|cooldown.final_reckoning.remains%gcd+holy_power>7)&(!covenant.necrolord.enabled|cooldown.vanquishers_hammer.remains>gcd)|talent.holy_avenger.enabled&cooldown.holy_avenger.remains<gcd*3|buff.holy_avenger.up|buff.crusade.up&buff.crusade.stack<10|buff.vanquishers_hammer.up
 if { not hastalent(crusade_talent) or spellcooldown(crusade) > gcd() * 3 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) / gcd() + holypower() > 7 or target.timetodie() < 8 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) / gcd() + holypower() > 7 } and { not iscovenant("necrolord") or spellcooldown(vanquishers_hammer) > gcd() } or hastalent(holy_avenger_talent) and spellcooldown(holy_avenger) < gcd() * 3 or buffpresent(holy_avenger) or buffpresent(crusade) and buffstacks(crusade) < 10 or buffpresent(vanquishers_hammer) spell(templars_verdict)
}

AddFunction retributionfinishersmainpostconditions
{
}

AddFunction retributionfinishersshortcdactions
{
 #variable,name=ds_castable,value=spell_targets.divine_storm>=2|buff.empyrean_power.up&debuff.judgment.down&buff.divine_purpose.down
 #seraphim,if=((!talent.crusade.enabled&(cooldown.avenging_wrath.remains>25|cooldown.avenging_wrath.remains=0))|(talent.execution_sentence.enabled&talent.final_reckoning.enabled)|(buff.crusade.up|cooldown.crusade.remains>25))&(!talent.final_reckoning.enabled|cooldown.final_reckoning.remains<8)&(!talent.execution_sentence.enabled|cooldown.execution_sentence.remains<8)&time_to_hpg=0
 if { not hastalent(crusade_talent) and { spellcooldown(avenging_wrath) > 25 or not spellcooldown(avenging_wrath) > 0 } or hastalent(execution_sentence_talent) and hastalent(final_reckoning_talent) or buffpresent(crusade) or spellcooldown(crusade) > 25 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) < 8 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) < 8 } and retributiontimetohpg() == 0 spell(seraphim)
 #vanquishers_hammer,if=(!talent.final_reckoning.enabled|cooldown.final_reckoning.remains>gcd*10|debuff.final_reckoning.up)&(!talent.execution_sentence.enabled|cooldown.execution_sentence.remains>gcd*10|debuff.execution_sentence.up)|spell_targets.divine_storm>=2
 if { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > gcd() * 10 or target.debuffpresent(final_reckoning) } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > gcd() * 10 or target.debuffpresent(execution_sentence) } or enemies(tagged=1) >= 2 spell(vanquishers_hammer)
 #execution_sentence,if=((!talent.crusade.enabled|buff.crusade.down&cooldown.crusade.remains>10)|buff.crusade.stack>=3|cooldown.avenging_wrath.remains>10|debuff.final_reckoning.up)&time_to_hpg=0&target.time_to_die>8
 if { not hastalent(crusade_talent) or buffexpires(crusade) and spellcooldown(crusade) > 10 or buffstacks(crusade) >= 3 or spellcooldown(avenging_wrath) > 10 or target.debuffpresent(final_reckoning) } and retributiontimetohpg() == 0 and target.timetodie() > 8 spell(execution_sentence)
}

AddFunction retributionfinishersshortcdpostconditions
{
 ds_castable() and not buffpresent(vanquishers_hammer) and { { not hastalent(crusade_talent) or spellcooldown(crusade) > gcd() * 3 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) / gcd() + holypower() > 7 or target.timetodie() < 8 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) / gcd() + holypower() > 7 } or enemies(tagged=1) >= 2 and { hastalent(holy_avenger_talent) and spellcooldown(holy_avenger) < gcd() * 3 or buffpresent(crusade) and buffstacks(crusade) < 10 } } and spell(divine_storm) or { { not hastalent(crusade_talent) or spellcooldown(crusade) > gcd() * 3 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) / gcd() + holypower() > 7 or target.timetodie() < 8 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) / gcd() + holypower() > 7 } and { not iscovenant("necrolord") or spellcooldown(vanquishers_hammer) > gcd() } or hastalent(holy_avenger_talent) and spellcooldown(holy_avenger) < gcd() * 3 or buffpresent(holy_avenger) or buffpresent(crusade) and buffstacks(crusade) < 10 or buffpresent(vanquishers_hammer) } and spell(templars_verdict)
}

AddFunction retributionfinisherscdactions
{
}

AddFunction retributionfinisherscdpostconditions
{
 { not hastalent(crusade_talent) and { spellcooldown(avenging_wrath) > 25 or not spellcooldown(avenging_wrath) > 0 } or hastalent(execution_sentence_talent) and hastalent(final_reckoning_talent) or buffpresent(crusade) or spellcooldown(crusade) > 25 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) < 8 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) < 8 } and retributiontimetohpg() == 0 and spell(seraphim) or { { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) > gcd() * 10 or target.debuffpresent(final_reckoning) } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) > gcd() * 10 or target.debuffpresent(execution_sentence) } or enemies(tagged=1) >= 2 } and spell(vanquishers_hammer) or { not hastalent(crusade_talent) or buffexpires(crusade) and spellcooldown(crusade) > 10 or buffstacks(crusade) >= 3 or spellcooldown(avenging_wrath) > 10 or target.debuffpresent(final_reckoning) } and retributiontimetohpg() == 0 and target.timetodie() > 8 and spell(execution_sentence) or ds_castable() and not buffpresent(vanquishers_hammer) and { { not hastalent(crusade_talent) or spellcooldown(crusade) > gcd() * 3 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) / gcd() + holypower() > 7 or target.timetodie() < 8 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) / gcd() + holypower() > 7 } or enemies(tagged=1) >= 2 and { hastalent(holy_avenger_talent) and spellcooldown(holy_avenger) < gcd() * 3 or buffpresent(crusade) and buffstacks(crusade) < 10 } } and spell(divine_storm) or { { not hastalent(crusade_talent) or spellcooldown(crusade) > gcd() * 3 } and { not hastalent(execution_sentence_talent) or spellcooldown(execution_sentence) / gcd() + holypower() > 7 or target.timetodie() < 8 } and { not hastalent(final_reckoning_talent) or spellcooldown(final_reckoning) / gcd() + holypower() > 7 } and { not iscovenant("necrolord") or spellcooldown(vanquishers_hammer) > gcd() } or hastalent(holy_avenger_talent) and spellcooldown(holy_avenger) < gcd() * 3 or buffpresent(holy_avenger) or buffpresent(crusade) and buffstacks(crusade) < 10 or buffpresent(vanquishers_hammer) } and spell(templars_verdict)
}

### actions.cooldowns

AddFunction retributioncooldownsmainactions
{
 #blessing_of_the_seasons
 spell(blessing_of_the_seasons)
}

AddFunction retributioncooldownsmainpostconditions
{
}

AddFunction retributioncooldownsshortcdactions
{
 unless spell(blessing_of_the_seasons)
 {
  #final_reckoning,if=holy_power>=3&cooldown.avenging_wrath.remains>gcd&time_to_hpg=0&(!talent.seraphim.enabled|buff.seraphim.up)
  if holypower() >= 3 and spellcooldown(avenging_wrath) > gcd() and retributiontimetohpg() == 0 and { not hastalent(seraphim_talent) or buffpresent(seraphim) } spell(final_reckoning)
 }
}

AddFunction retributioncooldownsshortcdpostconditions
{
 spell(blessing_of_the_seasons)
}

AddFunction retributioncooldownscdactions
{
 #potion,if=(buff.bloodlust.react|buff.avenging_wrath.up&buff.avenging_wrath.remains>18|buff.crusade.up&buff.crusade.remains<25)
 if { buffpresent(bloodlust) or buffpresent(avenging_wrath) and buffremaining(avenging_wrath) > 18 or buffpresent(crusade) and buffremaining(crusade) < 25 } and { checkboxon(opt_use_consumables) and target.classification(worldboss) } item(potion_of_spectral_strength_item usable=1)
 #lights_judgment,if=spell_targets.lights_judgment>=2|(!raid_event.adds.exists|raid_event.adds.in>75)
 if enemies(tagged=1) >= 2 or not never(raid_event_adds_exists) or 600 > 75 spell(lights_judgment)
 #fireblood,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack=10
 if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) == 10 spell(fireblood)
 #shield_of_vengeance
 if checkboxon(opt_shield_of_vengeance) spell(shield_of_vengeance)

 unless spell(blessing_of_the_seasons)
 {
  #use_item,name=inscrutable_quantum_device,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack>=10|cooldown.avenging_wrath.remains>45|cooldown.crusade.remains>45
  if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) >= 10 or spellcooldown(avenging_wrath) > 45 or spellcooldown(crusade) > 45 retributionuseitemactions()
  #use_item,name=overwhelming_power_crystal,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack>=10
  if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) >= 10 retributionuseitemactions()
  #use_item,name=darkmoon_deck_voracity,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack>=10
  if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) >= 10 retributionuseitemactions()
  #use_item,name=macabre_sheet_music,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack>=10
  if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) >= 10 retributionuseitemactions()
  #use_item,name=dreadfire_vessel,if=(!talent.execution_sentence.enabled|debuff.execution_sentence.up|cooldown.execution_sentence.remains>25)
  if not hastalent(execution_sentence_talent) or target.debuffpresent(execution_sentence) or spellcooldown(execution_sentence) > 25 retributionuseitemactions()
  #use_item,name=skulkers_wing,if=(!talent.execution_sentence.enabled|debuff.execution_sentence.up|cooldown.execution_sentence.remains>25)
  if not hastalent(execution_sentence_talent) or target.debuffpresent(execution_sentence) or spellcooldown(execution_sentence) > 25 retributionuseitemactions()
  #use_item,name=grim_codex,if=(!talent.execution_sentence.enabled|debuff.execution_sentence.up|cooldown.execution_sentence.remains>25)
  if not hastalent(execution_sentence_talent) or target.debuffpresent(execution_sentence) or spellcooldown(execution_sentence) > 25 retributionuseitemactions()
  #use_item,name=memory_of_past_sins,if=(!talent.execution_sentence.enabled|debuff.execution_sentence.up)
  if not hastalent(execution_sentence_talent) or target.debuffpresent(execution_sentence) retributionuseitemactions()
  #use_item,name=spare_meat_hook,if=(!talent.execution_sentence.enabled|debuff.execution_sentence.up)
  if not hastalent(execution_sentence_talent) or target.debuffpresent(execution_sentence) retributionuseitemactions()
  #use_item,name=sinful_gladiators_badge_of_ferocity,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack>=10|cooldown.avenging_wrath.remains>45|cooldown.crusade.remains>45
  if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) >= 10 or spellcooldown(avenging_wrath) > 45 or spellcooldown(crusade) > 45 retributionuseitemactions()
  #use_item,name=sinful_aspirants_badge_of_ferocity,if=buff.avenging_wrath.up|buff.crusade.up&buff.crusade.stack>=10|cooldown.avenging_wrath.remains>45|cooldown.crusade.remains>45
  if buffpresent(avenging_wrath) or buffpresent(crusade) and buffstacks(crusade) >= 10 or spellcooldown(avenging_wrath) > 45 or spellcooldown(crusade) > 45 retributionuseitemactions()
  #avenging_wrath,if=(holy_power>=4&time<5|holy_power>=3&time>5|talent.holy_avenger.enabled&cooldown.holy_avenger.remains=0)&(!talent.seraphim.enabled|cooldown.seraphim.remains>0)
  if { holypower() >= 4 and timeincombat() < 5 or holypower() >= 3 and timeincombat() > 5 or hastalent(holy_avenger_talent) and not spellcooldown(holy_avenger) > 0 } and { not hastalent(seraphim_talent) or spellcooldown(seraphim) > 0 } spell(avenging_wrath)
  #crusade,if=(holy_power>=4&time<5|holy_power>=3&time>5|talent.holy_avenger.enabled&cooldown.holy_avenger.remains=0)
  if holypower() >= 4 and timeincombat() < 5 or holypower() >= 3 and timeincombat() > 5 or hastalent(holy_avenger_talent) and not spellcooldown(holy_avenger) > 0 spell(crusade)
  #ashen_hallow
  spell(ashen_hallow)
  #holy_avenger,if=time_to_hpg=0&((buff.avenging_wrath.up|buff.crusade.up)|(buff.avenging_wrath.down&cooldown.avenging_wrath.remains>40|buff.crusade.down&cooldown.crusade.remains>40))
  if retributiontimetohpg() == 0 and { buffpresent(avenging_wrath) or buffpresent(crusade) or buffexpires(avenging_wrath) and spellcooldown(avenging_wrath) > 40 or buffexpires(crusade) and spellcooldown(crusade) > 40 } spell(holy_avenger)
 }
}

AddFunction retributioncooldownscdpostconditions
{
 spell(blessing_of_the_seasons) or holypower() >= 3 and spellcooldown(avenging_wrath) > gcd() and retributiontimetohpg() == 0 and { not hastalent(seraphim_talent) or buffpresent(seraphim) } and spell(final_reckoning)
}

### actions.default

AddFunction retribution_defaultmainactions
{
 #call_action_list,name=cooldowns
 retributioncooldownsmainactions()

 unless retributioncooldownsmainpostconditions()
 {
  #call_action_list,name=generators
  retributiongeneratorsmainactions()
 }
}

AddFunction retribution_defaultmainpostconditions
{
 retributioncooldownsmainpostconditions() or retributiongeneratorsmainpostconditions()
}

AddFunction retribution_defaultshortcdactions
{
 #auto_attack
 retributiongetinmeleerange()
 #call_action_list,name=cooldowns
 retributioncooldownsshortcdactions()

 unless retributioncooldownsshortcdpostconditions()
 {
  #call_action_list,name=generators
  retributiongeneratorsshortcdactions()
 }
}

AddFunction retribution_defaultshortcdpostconditions
{
 retributioncooldownsshortcdpostconditions() or retributiongeneratorsshortcdpostconditions()
}

AddFunction retribution_defaultcdactions
{
 #rebuke
 retributioninterruptactions()
 #call_action_list,name=cooldowns
 retributioncooldownscdactions()

 unless retributioncooldownscdpostconditions()
 {
  #call_action_list,name=generators
  retributiongeneratorscdactions()
 }
}

AddFunction retribution_defaultcdpostconditions
{
 retributioncooldownscdpostconditions() or retributiongeneratorscdpostconditions()
}

### Retribution icons.

AddCheckBox(opt_paladin_retribution_aoe l(aoe) default enabled=(specialization(retribution)))

AddIcon enabled=(not checkboxon(opt_paladin_retribution_aoe) and specialization(retribution)) enemies=1 help=shortcd
{
 if not incombat() retributionprecombatshortcdactions()
 retribution_defaultshortcdactions()
}

AddIcon enabled=(checkboxon(opt_paladin_retribution_aoe) and specialization(retribution)) help=shortcd
{
 if not incombat() retributionprecombatshortcdactions()
 retribution_defaultshortcdactions()
}

AddIcon enabled=(specialization(retribution)) enemies=1 help=main
{
 if not incombat() retributionprecombatmainactions()
 retribution_defaultmainactions()
}

AddIcon enabled=(checkboxon(opt_paladin_retribution_aoe) and specialization(retribution)) help=aoe
{
 if not incombat() retributionprecombatmainactions()
 retribution_defaultmainactions()
}

AddIcon enabled=(not checkboxon(opt_paladin_retribution_aoe) and specialization(retribution)) enemies=1 help=cd
{
 if not incombat() retributionprecombatcdactions()
 retribution_defaultcdactions()
}

AddIcon enabled=(checkboxon(opt_paladin_retribution_aoe) and specialization(retribution)) help=cd
{
 if not incombat() retributionprecombatcdactions()
 retribution_defaultcdactions()
}

### Required symbols
# arcane_torrent
# ashen_hallow
# avenging_wrath
# blade_of_justice
# blessing_of_the_seasons
# bloodlust
# consecration
# crusade
# crusade_talent
# crusader_strike
# divine_purpose_buff
# divine_storm
# divine_toll
# empyrean_power_buff
# execution_sentence
# execution_sentence_talent
# final_reckoning
# final_reckoning_talent
# fireblood
# hammer_of_justice
# hammer_of_wrath
# holy_avenger
# holy_avenger_talent
# judgment
# judgment_debuff
# lights_judgment
# potion_of_spectral_strength_item
# rebuke
# seraphim
# seraphim_talent
# shield_of_vengeance
# templars_verdict
# vanquishers_hammer
# wake_of_ashes
# war_stomp
]]
        scripts:registerScript("PALADIN", "retribution", name, desc, code, "script")
    end
end
